#!/usr/bin/tclsh
#
# htmlglue - to assembler html in template
# Version:  1.2
# Copyright (C) 2004 Piera "Vampiera" Poggio
#
# This is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This software is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with this software; if not, write to the Free
# Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#
#
# per freewrap
#
catch {console hide}

set imgsmile {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}
set imgvamp {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}

namespace eval Static {
	variable title HtmlGlue
	variable release 1.2
	variable basedir [pwd]
	variable from devel
	variable to release
	variable backup release_old
	variable default_template htmlglue_template.html

	variable tag_template htmlglue_template=
	variable tag_include htmlglue_include=
	variable tag_body htmlglue_body
	variable tag_macro htmlglue_macro=

	variable gui
	variable buff_template
	variable trace {}
	variable arr_include
	variable arr_template
	variable arr_body

	array set arr_include {}
	array set arr_template {}
	array set arr_body {}
}
namespace eval Macro {}
proc Macro::replace {from to where} {
	upvar $where toparse
	regsub $from $toparse $to toparse
}

proc gui_create {} {
	wm geometry . +100+100
	wm title . "$Static::title rel. $Static::release"
	set row 0
	frame .images
	image create photo imgsmile -data $::imgsmile
	label .images.s -image imgsmile
	pack .images.s -side left
	image create photo imgvamp -data $::imgvamp
	label .images.v -image imgvamp
	pack .images.v -side right
	pack .images -expand yes -fill x
	frame .static
	foreach {lbl1 lbl2} "Posizione Static::basedir Sviluppo Static::from Creazione Static::to Backup Static::backup Fase Static::trace" {
		label .static.${row}l1 -text $lbl1
		label .static.${row}l0 -text :
		switch $lbl1 {
			Fase {
				frame .static.${row}l2
				scrollbar .static.${row}l2.v -orient vertical -command [list .static.${row}l2.t yview]
				text .static.${row}l2.t -width 50 -height 10 \
				-state disabled \
				-background white \
				-yscrollcommand [list .static.${row}l2.v set]
				.static.${row}l2.t tag configure error -foreground red
				.static.${row}l2.t tag configure warning -foreground blue
				grid .static.${row}l2.t -row 0 -column 0
				grid .static.${row}l2.v -row 0 -column 1 -sticky ns
				set $lbl2 .static.${row}l2.t
			}
			default {
				label .static.${row}l2 -textvariable $lbl2 -width 50 -background white
			}
		}
		grid .static.${row}l1 -row $row -column 0 -sticky nw -pady 2
		grid .static.${row}l0 -row $row -column 1 -sticky nw -pady 2
		grid .static.${row}l2 -row $row -column 2 -sticky nw -pady 2
		incr row
	}

	pack .static -expand yes -fill x
	button .go -text Go\
		-command "go_create"
	pack .go
}
proc outmsg { go_out msg } {
	set back {}
	if $Static::gui {
		$Static::trace configure -state normal
		if {$go_out > 0} {
			$Static::trace insert end "$msg\n" warning
		} else {
			$Static::trace insert end "$msg\n"
		}
		if {$go_out == 1} {
			$Static::trace insert end "Impossibile proseguire\n" error
			set back return
		}
		$Static::trace see end
		$Static::trace configure -state disabled
	} else {
		puts $msg
		if {$go_out == 1} {
			puts "Impossibile proseguire - CHIUDO"
			exit
		}
	}
	return $back
}
proc get_body { input } {
	regsub <BODY> $input <body> input
	regsub </BODY> $input </body> input
	set from [string first <body> $input]
	set to [string first </body> $input]
	return [string range $input [expr $from + 6] [expr $to - 1]]
}
proc go_create {} {
	outmsg 0 "================"
	outmsg 0 "Inizializzazione [clock format [clock seconds] -format "%d/%m/%Y %H:%M:%S"]"
	if ![file isdirectory $Static::from] {
		eval [outmsg 1 "Directory $Static::from non esiste"]
	}

	array unset Static::arr_include *
	array unset Static::arr_template *
	array unset Static::arr_body *

	outmsg 0 "Caricamento struttura"
	foreach fullhtml [glob [file join $Static::from *.html]] {
		set myhtml [file tail $fullhtml]
		if [catch {set fd [open $fullhtml] } error] {
			eval [outmsg 1 "Errore caricamento $myhtml\n$error"]
		}
		fconfigure $fd -translation binary
		outmsg 0 "Analizzo $myhtml"
		set mybuff [read $fd]
		close $fd
		if [regexp -nocase $Static::default_template $myhtml] {
			set Static::arr_template($Static::default_template) $mybuff
			mem_tag Static::arr_include [get_tag $Static::tag_include include mybuff]
		} else {
			mem_tag Static::arr_template [get_tag $Static::tag_template template mybuff]
			mem_tag Static::arr_include [get_tag $Static::tag_include include mybuff]
			set Static::arr_body($myhtml) $mybuff
		}
	}
	outmsg 0 "Verifica struttura"
	if ![info exist Static::arr_template($Static::default_template)] {
		eval [outmsg 1 "File $Static::default_template non esiste"]
	}
	foreach myhtml [array names Static::arr_template] {
		outmsg 0 "Verifico Template $myhtml"
		set result [check_tag Static::arr_template($myhtml) $Static::tag_body]
		if ![string length $result] {
			outmsg 2 "===> non ha body"
		}
	}
	foreach myhtml [array names Static::arr_include] {
		outmsg 0 "Verifico Include $myhtml"
		set result [check_tag Static::arr_include($myhtml) $Static::tag_body $Static::tag_include $Static::tag_template]
		if [string length $result] {
			outmsg 2 "===> $result non verranno considerati"
		}
	}
	foreach myhtml [array names Static::arr_body] {
		if { [info exist Static::arr_template($myhtml)] ||
		     [info exist Static::arr_include($myhtml)] } {
			array unset Static::arr_body($myhtml)
			continue
		}
		outmsg 0 "Verifico Body $myhtml"
		set result [check_tag Static::arr_body($myhtml) $Static::tag_body]
		if [string length $result] {
			outmsg 2 "===> $result non verranno considerati"
		}
	}

	if [file isdirectory $Static::backup] {
		file delete -force $Static::backup
	}
	if [file isdirectory $Static::to] {
		file rename $Static::to $Static::backup
	}
	if [catch {file mkdir $Static::to} error ] {
		eval [outmsg 1 "Impossibile create $Static::to\n$error"]
	}

	outmsg 0 "Creazione struttura"
	if [file isdirectory [file join $Static::from images]] {
		file copy [file join $Static::from images] $Static::to
	}
	if [file isdirectory [file join $Static::from others]] {
		file copy [file join $Static::from others] $Static::to
	}
	foreach myhtml [array names Static::arr_body] {
		outmsg 0 "Creo $myhtml"

		set myt [get_tag $Static::tag_template template Static::arr_body($myhtml)]
		if [string length $myt] {
			set subparse [get_body $Static::arr_template($myt)]
			regsub "<--$Static::tag_body-->" $Static::arr_template($myt) [get_body $Static::arr_body($myhtml)] body
		} else {
			set body [get_body $Static::arr_body($myhtml)]
		}

		set toparse $Static::arr_template($Static::default_template)
		regsub "<--$Static::tag_body-->" $toparse $body toparse

		foreach one [array names Static::arr_include] {
			regsub "<--$Static::tag_include$one-->" $toparse $Static::arr_include($one) toparse
		}
		foreach onemacro [get_tag $Static::tag_macro macro Static::arr_body($myhtml)] {
			if {$onemacro == "disable"} { break }
			catch {eval Macro::$onemacro toparse}
		}
		if [catch {set fd [open [file join $Static::to $myhtml] w] } error] {
			eval [outmsg 1 "Errore body out $myhtml\n$error"]
		}
		fconfigure $fd -translation binary
		puts $fd $toparse
		close $fd
	}
	outmsg 0 "Creazione Conclusa"
}

proc check_tag {inbuf args } {
	upvar $inbuf toparse

	set back [list]
	foreach onecheck $args {
		set idx [string first "<--$onecheck" $toparse]
		if {$idx < 0} { continue }
		lappend back $onecheck
	}
	return $back
}
proc get_tag { tag type inbuf } {
	upvar $inbuf toparse

	set back [list]
	set idx 0
	while 1 {
		set idx [string first "<--$tag" $toparse $idx]
		if {$idx < 0} { break }
		incr idx [expr [string length $tag] + 3]
		set ok [string first {-} $toparse $idx]
		set name [string range $toparse $idx [expr $ok - 1]]
		switch $type {
			include -
			template {
				if {[string tolower [file extension $name]] != ".html"} { continue}
			}
		}
		lappend back $name
		if {$type == "template"} { break }
	}
	return $back
}
proc mem_tag { inbuftag listname } {
	upvar $inbuftag memtag

	foreach onename $listname {
		if ![info exist memtag($onename)] {
			if [catch {set fd [open [file join $Static::from $onename]] } error] {
				eval [outmsg 1 "Errore fix $onename\n$error"]
			}
			set memtag($onename) [get_body [read $fd]]
			close $fd
		}
	}
}

set opt(-gui) 1
array set opt $argv
set Static::gui $opt(-gui)

if $opt(-gui) {
	package require Tk
	gui_create
} else {
	go_create
}
